<?php

namespace modules\imagehelpers\twigextensions;

use modules\imagehelpers\ImageHelpers;

use Craft;
use craft\elements\Asset;
use craft\image\Raster;
use craft\helpers\ImageTransforms;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;
use Imagick;

class ImageHelpersTwigExtension extends AbstractExtension
{
  
    public function getName()
    {
        return 'ImageHelpers';
    }
    public function getFunctions()
    {
        return [
            new TwigFunction('isTransparent', [$this, 'getIsTransparent']), 
        ];
    }

    public function getIsTransparent($asset) 
    {
        if (!isset($asset)) {
            return null;
        } else {

            $images = Craft::$app->getImages();
            $localCopy = ImageTransforms::getLocalImageSource($asset);
            $image = $images->loadImage($localCopy, true);
            return $image->getIsTransparent();

            // Alternative test
            // $localCopy = ImageTransforms::getLocalImageSource($asset);
            // $imgk = new Imagick();
            // $imgk->readImage($localCopy);
            // return $imgk->getImageAlphaChannel() ? 1 : 0;

        }
    }
    
}
